/*******************************************************************************
 System Interrupt Source File

  File Name:
    sys_interrupt_a.S

  Summary:
    Raw ISR definitions.

  Description:
    This file contains a definitions of the raw ISRs required to support the 
    interrupt sub-system.
*******************************************************************************/

// DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) 2011-2014 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED AS IS WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 *******************************************************************************/
// DOM-IGNORE-END
/*
*********************************************************************************************************
*                                           INCLUDES
*********************************************************************************************************
*/
#include <xc.h>



#include "ISR_Support.h"

/* ADC Interrupt */
   .extern  IntHandlerDrvAdc

   .section	.vector_44,code, keep
   .equ     __vector_dispatch_44, IntVectorDrvAdc
   .global  __vector_dispatch_44
   .set     nomicromips
   .set     noreorder
   .set     nomips16
   .set     noat
   .ent  IntVectorDrvAdc

IntVectorDrvAdc:
    portSAVE_CONTEXT
    la    s6,  IntHandlerDrvAdc
    jalr  s6
    nop
    portRESTORE_CONTEXT
    .end	IntVectorDrvAdc



 

/* TMR Instance 1 Interrupt */
   .extern  IntHandlerDrvTmrInstance1

   .section	.vector_19,code, keep
   .equ     __vector_dispatch_19, IntVectorDrvTmrInstance1
   .global  __vector_dispatch_19
   .set     nomicromips
   .set     noreorder
   .set     nomips16
   .set     noat
   .ent  IntVectorDrvTmrInstance1

IntVectorDrvTmrInstance1:
    portSAVE_CONTEXT
    la    s6,  IntHandlerDrvTmrInstance1
    jalr  s6
    nop
    portRESTORE_CONTEXT
    .end	IntVectorDrvTmrInstance1


/* TMR Instance 2 Interrupt */
   .extern  IntHandlerDrvTmrInstance2

   .section	.vector_24,code, keep
   .equ     __vector_dispatch_24, IntVectorDrvTmrInstance2
   .global  __vector_dispatch_24
   .set     nomicromips
   .set     noreorder
   .set     nomips16
   .set     noat
   .ent  IntVectorDrvTmrInstance2

IntVectorDrvTmrInstance2:
    portSAVE_CONTEXT
    la    s6,  IntHandlerDrvTmrInstance2
    jalr  s6
    nop
    portRESTORE_CONTEXT
    .end	IntVectorDrvTmrInstance2


/* TMR Instance 3 Interrupt */
   .extern  IntHandlerDrvTmrInstance3

   .section	.vector_14,code, keep
   .equ     __vector_dispatch_14, IntVectorDrvTmrInstance3
   .global  __vector_dispatch_14
   .set     nomicromips
   .set     noreorder
   .set     nomips16
   .set     noat
   .ent  IntVectorDrvTmrInstance3

IntVectorDrvTmrInstance3:
    portSAVE_CONTEXT
    la    s6,  IntHandlerDrvTmrInstance3
    jalr  s6
    nop
    portRESTORE_CONTEXT
    .end	IntVectorDrvTmrInstance3




/* USART Instance 0 Interrupt */

   .extern  IntHandlerDrvUsartReceiveInstance0

   .section	.vector_146,code, keep
   .equ     __vector_dispatch_146, IntVectorDrvUsartReceiveInstance0
   .global  __vector_dispatch_146
   .set     nomicromips
   .set     noreorder
   .set     nomips16
   .set     noat
   .ent  IntVectorDrvUsartReceiveInstance0

IntVectorDrvUsartReceiveInstance0:
    portSAVE_CONTEXT
    la    s6,  IntHandlerDrvUsartReceiveInstance0
    jalr  s6
    nop
    portRESTORE_CONTEXT
    .end	IntVectorDrvUsartReceiveInstance0


   .extern  IntHandlerDrvUsartTransmitInstance0

   .section	.vector_147,code, keep
   .equ     __vector_dispatch_147, IntVectorDrvUsartTransmitInstance0
   .global  __vector_dispatch_147
   .set     nomicromips
   .set     noreorder
   .set     nomips16
   .set     noat
   .ent  IntVectorDrvUsartTransmitInstance0

IntVectorDrvUsartTransmitInstance0:
    portSAVE_CONTEXT
    la    s6,  IntHandlerDrvUsartTransmitInstance0
    jalr  s6
    nop
    portRESTORE_CONTEXT
    .end	IntVectorDrvUsartTransmitInstance0


   .extern  IntHandlerDrvUsartErrorInstance0

   .section	.vector_145,code, keep
   .equ     __vector_dispatch_145, IntVectorDrvUsartErrorInstance0
   .global  __vector_dispatch_145
   .set     nomicromips
   .set     noreorder
   .set     nomips16
   .set     noat
   .ent  IntVectorDrvUsartErrorInstance0

IntVectorDrvUsartErrorInstance0:
    portSAVE_CONTEXT
    la    s6,  IntHandlerDrvUsartErrorInstance0
    jalr  s6
    nop
    portRESTORE_CONTEXT
    .end	IntVectorDrvUsartErrorInstance0


/* OC Instance 0 Interrupt */
   .extern  IntHandlerDrvOCInstance0

   .section	.vector_12,code, keep
   .equ     __vector_dispatch_12, IntVectorDrvOCInstance0
   .global  __vector_dispatch_12
   .set     nomicromips
   .set     noreorder
   .set     nomips16
   .set     noat
   .ent  IntVectorDrvOCInstance0

IntVectorDrvOCInstance0:
    portSAVE_CONTEXT
    la    s6,  IntHandlerDrvOCInstance0
    jalr  s6
    nop
    portRESTORE_CONTEXT
    .end	IntVectorDrvOCInstance0


/* OC Instance 1 Interrupt */
   .extern  IntHandlerDrvOCInstance1

   .section	.vector_17,code, keep
   .equ     __vector_dispatch_17, IntVectorDrvOCInstance1
   .global  __vector_dispatch_17
   .set     nomicromips
   .set     noreorder
   .set     nomips16
   .set     noat
   .ent  IntVectorDrvOCInstance1

IntVectorDrvOCInstance1:
    portSAVE_CONTEXT
    la    s6,  IntHandlerDrvOCInstance1
    jalr  s6
    nop
    portRESTORE_CONTEXT
    .end	IntVectorDrvOCInstance1


/*******************************************************************************
 End of File
 */

