#include "fenetre.h"

#include <QDebug>
#include <QKeyEvent>
#include <QCoreApplication>
#include <QGraphicsEffect>


Fenetre::Fenetre(int x, int y):QWidget ()
{
    this->setGeometry(50,50,x+50,y+50);

    /* Création objet mouvement */
    mvt my_move;

    /* Initialisation des variables manettes */
    apressed=false;
    bpressed=false;
    leftpressed=false;
    rightpressed=false;

    /* Création du réseaux */
    soc = new QTcpSocket(this);
    port = 22;
    IP = "192.168.1.1";
    connexionok=false;


    /*bouton pour couper la connexion */
    close_bouton = new QPushButton(this);
    close_bouton -> setIcon(QIcon("close.png"));
    close_bouton->setIconSize(QSize(50,62));
    close_bouton->setStyleSheet("QPushButton{background: transparent;}");
    close_bouton->setGeometry(30,30,90,90);
    QObject::connect(close_bouton,SIGNAL(clicked()),this,SLOT(deconnexion1()));

    /* LCD afficher vitesse */
    setStyleSheet("border : 0px solid black; color:cyan;");
    QLCDNumber *lcd = new QLCDNumber(this);
    lcd->setSegmentStyle(QLCDNumber::Flat);
    lcd-> setMinimumWidth(100);
    lcd-> setMinimumHeight(100);
    lcd-> setGeometry(600,300,200,200);
    QObject::connect(this,SIGNAL(vit(int)),lcd,SLOT(display(int)));

    /* Fond de la fenetre */
    fond1.setBrush(backgroundRole(),QBrush(QImage("connect_bkg.png"))); // Ecran d'acceuil
    fond2.setBrush(backgroundRole(),QBrush(QImage("bkg2.png"))); // Ecran connecté
    setPalette(fond1);

    /*Bouton de connexion */
    connexion_boutton =new QPushButton(this);
    connexion_boutton->setMaximumSize(375,150);
    connexion_boutton -> setIcon(QIcon("connect_bouton.png"));
    connexion_boutton->setIconSize(QSize(375,150));
    connexion_boutton->setStyleSheet("QPushButton{background: transparent;}");
    connect(connexion_boutton,SIGNAL(clicked()),this,SLOT(connexion()));

    QVBoxLayout *Vlayout = new QVBoxLayout;
    Vlayout-> addWidget(connexion_boutton);
    Vlayout->setAlignment(connexion_boutton,Qt::AlignHCenter);
    this->setLayout(Vlayout);

    /*Bouton help*/
    help = new QPushButton(this);
    help->setMaximumSize(50,62);
    help -> setIcon(QIcon("help.png"));
    help->setIconSize(QSize(50,62));
    help->setStyleSheet("QPushButton{background: transparent;}");
    help-> setGeometry(50,700-20,92,730-20);
    QObject::connect(help,SIGNAL(clicked()),this,SLOT(helpWindow()));

    /* Test debug */
    /*
    l1 = new QLabel(this);
    l1->setStyleSheet("QLabel { background-color : red; color : blue; }");
    l1->setText("Hello World");
    //l1->setFixedSize(100,100);
    */

    /* Création des timers */
    timer = new QTimer(this);
    sendTimer = new QTimer(this);
}

void Fenetre::closeEvent(QCloseEvent *event)
{
    fenetrequit1();
}

void
Fenetre::connexion()
{
    connexion_boutton->setEnabled(false);
    soc->abort();   //désactive les anciennes connexions
    connexionok=false;
    soc->connectToHost(IP,port);

    connect(soc, SIGNAL(readyRead()), this, SLOT(receive()));

    QTimer *timers = new QTimer(this);
    timers->setSingleShot(true);
    connect(timers, SIGNAL(timeout()), this, SLOT(checkconnexion()));
    timers -> start(100);

}

void
Fenetre::fenetrequit1()
{
    disconnect(sendTimer,SIGNAL(timeout()),this,SLOT(send()));
    disconnect(soc, SIGNAL(disconnected()), this, SLOT(errconnexion()));
    QTimer *timers = new QTimer(this);
    timers->setSingleShot(true);
    connect(timers, SIGNAL(timeout()), this, SLOT(fenetrequit2()));
    timers -> start(50);
}

void
Fenetre::fenetrequit2()
{
    char message[] = "Goodbye Client!\n\r";
    soc -> write(message);
    QTimer *timers = new QTimer(this);
    timers->setSingleShot(true);
    connect(timers, SIGNAL(timeout()), qApp, SLOT(quit()));
    timers -> start(50);
}

void
Fenetre::deconnexion1()
{
    disconnect(sendTimer,SIGNAL(timeout()),this,SLOT(send()));
    disconnect(soc, SIGNAL(disconnected()), this, SLOT(errconnexion()));
    QTimer *timers = new QTimer(this);
    timers->setSingleShot(true);
    connect(timers, SIGNAL(timeout()), this, SLOT(deconnexion2()));
    timers -> start(50);
}

void
Fenetre::deconnexion2()
{
    char message[] = "Goodbye Client!\n\r";
    soc -> write(message);
    QTimer *timers = new QTimer(this);
    timers->setSingleShot(true);
    connect(timers, SIGNAL(timeout()), this, SLOT(errconnexion()));
    timers -> start(50);
}

void
Fenetre::checkconnexion()
{
    if (connexionok) {
        MainWindow(true);
        connect(soc, SIGNAL(disconnected()), this, SLOT(errconnexion()));
    }
    else {
        disconnect(soc, SIGNAL(readyRead()), this, SLOT(receive()));
        soc->abort();
        warningcoWindow();
        connexion_boutton->setEnabled(true);
    }

}


void
Fenetre::errconnexion()
{
    soc->abort();
    connexionok=false;
    MainWindow(false);
    warningcoWindow();
}

void
Fenetre::send()
{
    char message[50];
    sprintf(message,"%d:%d",my_move.getVit(),my_move.getDir());
    soc -> write(message);

}

void
Fenetre::receive()
{
    QByteArray datas = soc->readAll();
    QString msg=QString(datas);
    if (msg == "Hello Client!\n\r") {
        connexionok=true;
    }
    else if (msg != NULL) {
        //l1->setText(msg);
        emit newPwr(msg);
    }

}

void
Fenetre::MainWindow(bool state)
{
    if (state) {

        connexion_boutton->setVisible(false);

        /* Fond de la fenetre */
        setPalette(fond2);

        this-> grabKeyboard(); /* permet de detecter tout le clavier ! */


        /* Création des timers */
        connect(timer, SIGNAL(timeout()), this, SLOT(update()));
        timer -> start(50);

        connect(sendTimer,SIGNAL(timeout()),this,SLOT(send()));
        sendTimer->start(100);
    }
    else {
        connexion_boutton->setVisible(true);
        connexion_boutton->setEnabled(true);
        setPalette(fond1);
        this-> releaseKeyboard();
        timer -> stop();
        disconnect(timer, SIGNAL(timeout()), this, SLOT(update()));
        sendTimer->stop();
        disconnect(sendTimer,SIGNAL(timeout()),this,SLOT(send()));
    }
}


void
Fenetre::helpWindow()
{
    QMessageBox help;
    help.setIcon(QMessageBox::Information);
    if (connexionok) {
        help.setText("Utilisez les flèches directionnelles du clavier ou une manette afin de contrôler le robot. Vous pouvez vous déconnecter grâce au bouton en haut à gauche.");
    }
    else {
        help.setText("Pour utiliser l'application, connectez vous directement au robot via wifi et appuyez sur le bouton 'Connection'.");
    }
    help.exec();

}

void
Fenetre::warningcoWindow()
{
    QMessageBox wrn;
    wrn.setIcon(QMessageBox::Warning);
    wrn.setText("Connexion impossible.");
    wrn.exec();

}

void
Fenetre::aclicked(){
    apressed=!apressed;
    my_move.setFlagAv(apressed);
}

void
Fenetre::bclicked(){
    bpressed=!bpressed;
    my_move.setFlagAr(bpressed);
}

void
Fenetre::leftclicked(){
    leftpressed=!leftpressed;
    my_move.setFlagRight(leftpressed);
}

void
Fenetre::rightclicked(){
    rightpressed=!rightpressed;
    my_move.setFlagLeft(rightpressed);
}

mvt *
Fenetre::getMove(){
    return(&my_move);
}


void
Fenetre::keyPressEvent(QKeyEvent *event){
    if(!event->QKeyEvent::isAutoRepeat()){
        ::ReceptKeyboard::ReceptPressEvent(event, &my_move);
    }
}


void
Fenetre::keyReleaseEvent(QKeyEvent *event){
    if(!event->QKeyEvent::isAutoRepeat()){
       ::ReceptKeyboard::ReceptReleaseEvent(event, &my_move);
    }

}


void
Fenetre::paintEvent(QPaintEvent* event)
{
    QPainter painter(this);
    QColor myCol;
    //painter.setBrush(QColor(0,255,252));
    if(my_move.getVit()<30){
           myCol = QColor(0,255,252);
    }
    else{
        myCol = QColor(252,0,47);
    }
    QPen pen(myCol, 52, Qt::SolidLine, Qt::FlatCap, Qt::RoundJoin);
    painter.setPen(pen);

    /* Arc représentant la vitesse */
    QRectF rectangle(475, 125, 550, 550);
    int startAngle = -140 * 16;
    int spanAngle = -(my_move.getVit()) * 16*2.5;
    painter.setRenderHint(QPainter :: Antialiasing);
    painter.drawArc(rectangle, startAngle, 2*spanAngle);


    /*Arc représentannt la direction */
    pen.setWidth(31);
    painter.setPen(pen);
    QRectF rect(317, -33,866, 866);
    int Angle = (my_move.getDir()) * 16;
    painter.setRenderHint(QPainter :: Antialiasing);
    if(Angle<40*16){
       painter.drawArc(rect, 0, Angle);
    }
    else {
        painter.drawArc(rect, 0, 40*16);
    }

    emit vit(my_move.getVit());

}

