#include "fenetre.h"
#include "chart.h"
//#include "receptkeyboard.h"
#include <QApplication>
#include <QtCharts/QChartView>
#include <QtWidgets/QMainWindow>

#include <QQmlApplicationEngine>



int main(int argc, char *argv[])
{
    QApplication myApp(argc, argv);
    myApp.setWindowIcon(QIcon("icon.png"));

    /* Fenêtre principale */
    Fenetre ma_fenetre(1500,800);
    ma_fenetre.setFixedSize(1500,800); //Permet de verouiller la taille de la fenêtre à la taille recommandée

    /* Application Quick Gamepad QML */
    QQmlApplicationEngine engine;
    engine.load(QUrl(QStringLiteral("qrc:///qml/main.qml")));

    /* Chart */
    QMainWindow window;
    Chart *chart = new Chart;
    chart->setTitle("Power consumption");
    chart->legend()->hide();
    chart->setAnimationOptions(QChart::AllAnimations);
    QChartView chartView(chart);
    chartView.setRenderHint(QPainter::Antialiasing);
    window.setCentralWidget(&chartView);
    window.resize(400, 300);

    /* Connexions entre applications */
    QObject::connect(&ma_fenetre, SIGNAL(newPwr(QString)), chart, SLOT(newPwr(QString)));
    QObject* item = (QObject*)engine.rootObjects()[0]; //Nécessaire pour l'envoi des signaux QML vers c++
    QObject::connect(item, SIGNAL(aclicked()), &ma_fenetre, SLOT(aclicked()));
    QObject::connect(item, SIGNAL(bclicked()), &ma_fenetre, SLOT(bclicked()));
    QObject::connect(item, SIGNAL(leftclicked()), &ma_fenetre, SLOT(leftclicked()));
    QObject::connect(item, SIGNAL(rightclicked()), &ma_fenetre, SLOT(rightclicked()));


    ma_fenetre.show();
    window.show();

    return myApp.exec();
}
